Bug 3057 - adding 64bit windows printer drivers does not work
adding 64bit windows printer drivers does not work
Status: RESOLVED FIXED
Product: Samba 3.0
Classification: Unclassified
Component: Printing
3.0.20
x86 Linux
: P3 major
: none
Assigned To: Gerald (Jerry) Carter
Samba QA Contact
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2005-09-01 11:30 UTC by Moritz Baumann
Modified: 2005-09-30 04:05 UTC (History)
0 users

See Also:


Attachments
patch to assume x64 drivers are v3 (user mode) drivers. (883 bytes, patch)
2005-09-27 08:22 UTC, Gerald (Jerry) Carter
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Moritz Baumann 2005-09-01 11:30:54 UTC
pug and get to the print$\x64 share works:

[baumann@media6 ~]$ smbclient -U root \\\\localhost\\print\$
Password:
Domain=[MEDIA6] OS=[Unix] Server=[Samba 3.0.20]
smb: \> ls
  .                                   D        0  Thu Sep  1 14:26:08 2005
  ..                                  D        0  Thu Sep  1 16:33:16 2005
  W32X86                              D        0  Thu Sep  1 15:05:51 2005
  x64                                 D        0  Thu Sep  1 14:57:59 2005

                65216 blocks of size 32768. 44099 blocks available
smb: \> cd x64
smb: \x64\> ls
  .                                   D        0  Thu Sep  1 14:57:59 2005
  ..                                  D        0  Thu Sep  1 14:26:08 2005
  3                                   D        0  Thu Sep  1 14:57:59 2005
  HP4600_7.BPD                        A    50052  Thu Sep  1 14:26:17 2005
  HP4600_7.PPD                        A    56436  Thu Sep  1 14:26:17 2005
  hpc4600s.ini                        A      185  Thu Sep  1 14:26:17 2005
  hpcabout.dll                        A    23552  Thu Sep  1 14:26:17 2005
  HPCJRRPS.DLL                        A    13312  Thu Sep  1 14:26:17 2005
  HPCJRUI.DLL                         A    33280  Thu Sep  1 14:26:17 2005
  HPCLJX.HLP                          A    21866  Thu Sep  1 14:26:17 2005
  hpcstr.dll                          A     8704  Thu Sep  1 14:26:17 2005
  PS5UI.DLL                           A   237568  Thu Sep  1 14:26:17 2005
  PSCRIPT5.DLL                        A   733696  Thu Sep  1 14:26:17 2005
  PSCRIPT.HLP                         A    26038  Thu Sep  1 14:26:17 2005
  PSCRIPT.NTF                         A  1062696  Thu Sep  1 14:26:17 2005

                65216 blocks of size 32768. 44099 blocks available
smb: \x64\> get hpcstr.dll
getting file \x64\hpcstr.dll of size 8704 as hpcstr.dll (8499.2 kb/s) (average 8
500.0 kb/s)
smb: \x64\> put log.smbd
putting file log.smbd as \x64\log.smbd (35488.7 kb/s) (average 35492.2 kb/s)
smb: \x64\> quit

The files are from a Windows 2003 amd 64 installation.

[baumann@media6 ~]$ rpcclient -U root localhost -c 'adddriver "Windows x64" "HP
Color LaserJet 4600 PS":PSCRIPT5.DLL...
Password:
result was WERR_INVALID_PARAM

having run smbd -d 10

shows the following line in the log:

[2005/09/01 20:05:29, 3] printing/nt_printing.c:get_file_version(1063)
  get_file_version: PE file [x64/PSCRIPT5.DLL] wrong machine = 0x8664
Comment 1 Moritz Baumann 2005-09-07 01:39:36 UTC
doing a strings `which rpcclient` shows:

Rffpcnex test
Windows 4.0
WIN40
Windows NT x86
W32X86
Windows NT R4000
W32MIPS
Windows NT Alpha_AXP
W32ALPHA
Windows NT PowerPC
W32PPC
Windows IA64
Windows x64
Usage: %s <printername>

--

System is Fedora Core 4 with rebuild RPM from
http://us4.samba.org/samba/ftp/Binary_Packages/Fedora/SRPMS/samba-3.0.20-2.src.rpm
Comment 2 Guenther Deschner 2005-09-07 05:51:55 UTC
Jerry, I think we'll have to adapt to PECOFF headers for non i386 platforms
mentioned here:
http://www.microsoft.com/whdc/system/platform/firmware/PECOFF.mspx
Comment 3 Gerald (Jerry) Carter 2005-09-07 06:02:53 UTC
gd.  For now I think we can just assume all 64-bit drivers 
are version 3.
Comment 4 Moritz Baumann 2005-09-08 01:21:11 UTC
This is a connection to a native 2003 Server:

[baumann@media6 ~]$ smbclient -U ITWM\\root \\\\dagur\\print\$
Domain=[ITWM] OS=[Windows Server 2003 3790 Service Pack 1] Server=[Windows
Server 2003 5.2]
smb: \> dir
  .                                   D        0  Thu Sep  1 18:42:04 2005
  ..                                  D        0  Thu Sep  1 18:42:04 2005
  color                               D        0  Thu Jul 21 17:35:57 2005
  W32X86                              D        0  Thu Sep  1 18:42:04 2005
  x64                                 D        0  Wed Aug 31 16:35:07 2005

                49999 blocks of size 1048576. 40916 blocks available
smb: \> cd x64
smb: \x64\> dir
  .                                   D        0  Wed Aug 31 16:35:07 2005
  ..                                  D        0  Wed Aug 31 16:35:07 2005
  3                                   D        0  Thu Sep  1 12:00:09 2005

                49999 blocks of size 1048576. 40915 blocks available
smb: \x64\> cd 3
smb: \x64\3\> dir
  .                                   D        0  Thu Sep  1 12:00:09 2005
  ..                                  D        0  Thu Sep  1 12:00:09 2005
  APLWCSB1.BPD                        A    16956  Thu Aug 11 16:12:23 2005
  APLWCSB1.PPD                        A    19141  Thu Mar 24 17:11:58 2005
  HP4000_7.BPD                        A    22908  Thu Aug 11 16:12:19 2005
  HP4000_7.PPD                        A    33618  Thu Mar 24 17:18:52 2005
  HP4050_7.BPD                        A    29464  Thu Aug 11 16:12:21 2005
  HP4050_7.PPD                        A    41534  Thu Mar 24 17:18:52 2005
  HP4100_6.BPD                        A    30332  Thu Aug 11 16:12:18 2005
  HP4100_6.PPD                        A    43953  Thu Mar 24 17:18:52 2005
  HP4600_7.BPD                        A    50052  Thu Jul 21 17:28:46 2005
  HP4600_7.PPD                        A    56436  Thu Mar 24 17:18:52 2005
  HP8000_7.BPD                        A    37332  Thu Aug 11 16:12:20 2005
  HP8000_7.PPD                        A    69704  Thu Mar 24 17:18:52 2005
  hpc4600s.ini                        A      185  Thu Mar 24 17:18:52 2005
  hpcabout.dll                        A    23552  Thu Mar 24 17:18:52 2005
  HPCJRRPS.DLL                        A    13312  Thu Mar 24 17:18:52 2005
  HPCJRUI.DLL                         A    33280  Thu Mar 24 17:18:52 2005
  HPCLJX.GID                         AH     8628  Thu Jul 21 17:31:58 2005
  HPCLJX.HLP                          A    21866  Thu Mar 24 17:18:52 2005
  hpcstr.dll                          A     8704  Thu Mar 24 17:18:52 2005
  HPLJ5M_4.BPD                        A    19488  Wed Aug 31 16:31:44 2005
  HPLJ5M_4.PPD                        A    23229  Thu Mar 24 17:18:52 2005
  hpljps1.ini                         A      185  Thu Mar 24 17:18:52 2005
  PS5UI.DLL                           A   237568  Thu Mar 24 17:23:58 2005
  PSCRIPT.HLP                         A    26038  Thu Mar 24 17:23:58 2005
  PSCRIPT.NTF                         A  1062696  Thu Mar 24 17:23:58 2005
  PSCRIPT5.DLL                        A   733696  Thu Mar 24 17:23:58 2005

                49999 blocks of size 1048576. 40915 blocks available

Where I installed the driver connected to lpt1:.

Regards,
Moritz Baumann
Comment 5 Gerald (Jerry) Carter 2005-09-27 08:22:46 UTC
Created attachment 1457 [details]
patch to assume x64 drivers are v3 (user mode) drivers.

please try thsi patch and see if that fixes the 
driver upload problem.
Comment 6 Gerald (Jerry) Carter 2005-09-27 12:11:36 UTC
Marking as fixed.  Please reopen if the patch does not fix the problem.
Comment 7 Moritz Baumann 2005-09-28 06:51:53 UTC
rpcclient $> adddriver "Windows x64"
"HPCL4600PS":PSCRIPT5.DLL:HP4600_7.PPD:PS5UI.DLL:PSCRIPT.HLP:NULL:RAW:HPCJRRPS.DLL,HPCJRUI.DLL,hpcabout.dll,hpcstr.dll,hpc4600s.ini,PSCRIPT.NTF,HPCLJX.HLP
3
Printer Driver HPCL4600PS successfully installed.
rpcclient $> enumdrivers 3

[Windows NT x86]
Printer Driver Info 3:
        Version: [3]
        Driver Name: [HPCL4600PS]
        Architecture: [Windows NT x86]
        Driver Path: [\\\\LOCALHOST\print$\W32X86\3\PSCRIPT5.DLL]
        Datafile: [\\\\LOCALHOST\print$\W32X86\3\HPB46007.PPD]
        Configfile: [\\\\LOCALHOST\print$\W32X86\3\PS5UI.DLL]
        Helpfile: [\\\\LOCALHOST\print$\W32X86\3\PSCRIPT.HLP]

        Dependentfiles: [\\\\LOCALHOST\print$\W32X86\3\PSCRIPT.NTF]
        Dependentfiles: [\\\\LOCALHOST\print$\W32X86\3\HPBOEM80.NTF]
        Dependentfiles: [\\\\LOCALHOST\print$\W32X86\3\HPBPSJRR.DLL]
        Dependentfiles: [\\\\LOCALHOST\print$\W32X86\3\HPBPSJUI.DLL]
        Dependentfiles: [\\\\LOCALHOST\print$\W32X86\3\HPJRCSTR.DLL]
        Dependentfiles: [\\\\LOCALHOST\print$\W32X86\3\HPJRLJPS.INI]
        Dependentfiles: [\\\\LOCALHOST\print$\W32X86\3\HPBMMON.DLL]
        Dependentfiles: [\\\\LOCALHOST\print$\W32X86\3\HPDOMON.DLL]
        Dependentfiles: [\\\\LOCALHOST\print$\W32X86\3\HPBHEALR.DLL]

        Monitorname: []
        Defaultdatatype: [RAW]


[Windows x64]
Printer Driver Info 3:
        Version: [3]
        Driver Name: [HPCL4600PS]
        Architecture: [Windows x64]
        Driver Path: [\\\\LOCALHOST\print$\x64\3\PSCRIPT5.DLL]
        Datafile: [\\\\LOCALHOST\print$\x64\3\HP4600_7.PPD]
        Configfile: [\\\\LOCALHOST\print$\x64\3\PS5UI.DLL]
        Helpfile: [\\\\LOCALHOST\print$\x64\3\PSCRIPT.HLP]

        Dependentfiles: [\\\\LOCALHOST\print$\x64\3\HPCLJX.HLP]
        Dependentfiles: [\\\\LOCALHOST\print$\x64\3\PSCRIPT.NTF]
        Dependentfiles: [\\\\LOCALHOST\print$\x64\3\hpc4600s.ini]
        Dependentfiles: [\\\\LOCALHOST\print$\x64\3\hpcstr.dll]
        Dependentfiles: [\\\\LOCALHOST\print$\x64\3\hpcabout.dll]
        Dependentfiles: [\\\\LOCALHOST\print$\x64\3\HPCJRUI.DLL]
        Dependentfiles: [\\\\LOCALHOST\print$\x64\3\HPCJRRPS.DLL]

        Monitorname: []
        Defaultdatatype: [RAW]

rpcclient $>

shows the right stuff...

I have been unable to test it against a native 64bit windows... but will report
success or failure (but my guess is, that it will work).

Thanks a lot jerry
Comment 8 Moritz Baumann 2005-09-30 04:05:02 UTC
it seems to work.